<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="客户名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入客户名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="电话号码" prop="remarkMobiles">
        <el-input
          v-model="queryParams.remarkMobiles"
          placeholder="请输入备注电话号码"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['qw:externalContact:edit']"
        >修改</el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['qw:externalContact:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5" style="padding: 5px;margin-left: 10px;">
        <span>共有{{total}}个客户</span>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <el-tabs type="card" v-model="queryParams.stageStatus" @tab-click="handleClickX">
      <el-tab-pane v-for="(item,index) in stageOptions" :label="item.dictLabel" :name="item.dictValue"></el-tab-pane>
    </el-tabs>
    <el-table v-loading="loading" :data="externalContactList" @selection-change="handleSelectionChange" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="企微员工账号" align="center" prop="userId" width="120px"/>

      <el-table-column label="客户名称" align="center" prop="name" />
      <el-table-column label="头像" align="center" prop="avatar" width="120px">
        <template slot-scope="scope">
          <el-popover
            placement="right"
            title=""
            trigger="hover">
            <img slot="reference" :src="scope.row.avatar" width="100px">
            <img :src="scope.row.avatar" style="max-width: 150px;">
          </el-popover>
        </template>
      </el-table-column>

      <el-table-column label="性别" align="center" prop="gender">
        <template slot-scope="scope">
          <dict-tag :options="genderOptions" :value="scope.row.gender"/>
        </template>
      </el-table-column>
      <el-table-column label="标签" align="center" prop="tagIds" width="250px">
        <template slot-scope="scope">
          <div v-for="i in JSON.parse(scope.row.tagIds)" :key="i" style="display: inline;">
          <el-tag type="success" v-for="ii in tagList" :key="ii.id" style="margin: 3px;" v-if="ii.tagId==i">{{ii.name}}</el-tag>
          </div>
        </template>
      </el-table-column>
      <el-table-column label="电话" align="center" prop="remarkMobiles" width="150px">
        <template slot-scope="scope">
          <div v-for="i in JSON.parse(scope.row.remarkMobiles)" :key="i">{{i}}</div>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['qw:externalContact:edit']"
          >修改旅程</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 添加或修改企业微信客户对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">

        <el-form-item label="旅程" prop="stageStatus" style="margin-top: 20px;">
          <el-select v-model="form.stageStatus" placeholder="旅程">
            <el-option
              v-for="dict in stageOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="parseInt(dict.dictValue)"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { editStatus,addTag,delTag,listExternalContact, getExternalContact, delExternalContact, addExternalContact, updateExternalContact, exportExternalContact } from "@/api/qw/externalContact";
import { listTag, getTag, } from "@/api/qw/tag";
import { allListTagGroup} from "@/api/qw/tagGroup";
export default {
  name: "ExternalContact",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      tagOpen:false,
      tagDelOpen:false,
      // 选中数组
      ids: [],
      remarkMobiles: [],
      inputVisible: false,
      inputValue: '',
      // 非单个禁用
      single: true,
      tagGroupList: [],
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 企业微信客户表格数据
      externalContactList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 用户类别字典
      typeOptions: [],
      // 性别字典
      genderOptions: [],
      addTagForm:{
        userIds:[],
        tagIds:[]
      },
      // 来源字典
      addWayOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        externalUserId: null,
        name: null,
        avatar: null,
        type: null,
        gender: null,
        description: null,
        tagIds: null,
        remarkMobiles: null,
        remarkCorpName: null,
        addWay: null,
        operUserid: null,
        corpId: null,
        companyId: null,
        status:null,
        transferStatus:null,
        stageStatus:0
      },
      // 表单参数
      form: {},
      tagList:[],
      transferStatusOptions:[],
      stageOptions:[],
      statusOptions:[],
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_qw_externalContact_type").then(response => {
      this.typeOptions = response.data;
    });
    this.getDicts("sys_sex").then(response => {
      this.genderOptions = response.data;
    });
    this.getDicts("sys_qw_externalContact_addWay").then(response => {
      this.addWayOptions = response.data;
    });
    listTag().then(response => {
      this.tagList = response.rows;
    });
    this.getDicts("sys_qw_external_contact_status").then(response => {
      this.statusOptions = response.data;
    });
    this.getDicts("sys_qw_transfer_status").then(response => {
      this.transferStatusOptions = response.data;
    });
    this.getDicts("sys_qw_external_stage_status").then(response => {
      this.stageOptions = response.data;
    });
    allListTagGroup().then(response => {
        this.tagGroupList = response.rows;
      });
  },
  methods: {
    /** 查询企业微信客户列表 */
    getList() {
      this.loading = true;
      listExternalContact(this.queryParams).then(response => {
        this.externalContactList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    handleClickX(tab, event) {
      this.queryParams.stageStatus=tab.name;
      this.handleQuery();
    },
    handleClose(tag) {
      this.remarkMobiles.splice(this.remarkMobiles.indexOf(tag), 1);
    },
    showInput() {
      this.inputVisible = true;
      this.$nextTick(_ => {
        this.$refs.saveTagInput.$refs.input.focus();
      });
    },
    handleInputConfirm() {
      let inputValue = this.inputValue;
      if (inputValue) {
        this.remarkMobiles.push(inputValue);
      }
      this.inputVisible = false;
      this.inputValue = '';
    },





    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },

    // 表单重置
    reset() {
      this.form = {
        id: null,
        userId: null,
        externalUserId: null,
        name: null,
        avatar: null,
        type: null,
        gender: null,
        remark: null,
        description: null,
        tagIds: null,
        remarkMobiles: null,
        remarkCorpName: null,
        addWay: null,
        operUserid: null,
        corpId: null,
        companyId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
     addExternalContact(this.form).then(response => {
       this.msgSuccess("同步成功");
       this.getList();
     });

    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getExternalContact(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改企业微信客户";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            editStatus(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除企业微信客户编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delExternalContact(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有企业微信客户数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportExternalContact(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
<style scoped>
  .tag-box{
    margin: 10px;
    padding: 5px;
    background-color: #f0f0f0 ;
    border-radius: 4px;
  }
  .tag-selectd{
    background-color: rgb(231, 244, 255) ;
    border: 1px solid rgb(24, 144, 255) ;
  }
  .el-tag + .el-tag {
      margin-left: 10px;
    }
    .button-new-tag {
      margin-left: 10px;
      height: 32px;
      line-height: 30px;
      padding-top: 0;
      padding-bottom: 0;
    }
    .input-new-tag {
      width: 90px;
      margin-left: 10px;
      vertical-align: bottom;
    }
</style>
